;    crap.s is free software: you can redistribute it and/or modify
;    it under the terms of the GNU General Public License as published by
;    the Free Software Foundation, either version 3 of the License, or
;    (at your option) any later version.
;
;    crap.s is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;    GNU General Public License for more details.
;
;    You should have received a copy of the GNU General Public License
;    along with crap.  If not, see <http://www.gnu.org/licenses/>.
;
;
;    fuses: hfuse=0xff lfuse=0x6a ; so no fuse programming should be
;           necessary.
;

.org 0x00
reset:
    rjmp coldstart ; reset
    rjmp crap_int  ; int0
    rjmp crap_int  ; pcint0
    rjmp crap_int  ; tim0_ovf
    rjmp crap_int  ; ee_rdy
    rjmp crap_int  ; ana_comp
    rjmp crap_int  ; tim0_compa
    rjmp crap_int  ; tim0_compb
    rjmp crap_int  ; wdt
adcirq: ; this gets called 9600000/256=37500 times per sec.
    ; we save  2 cycles by not using rjmp to jump to the handler...
    out 0x38,r2  ; TIFR0 = (1 << TOV0) : ack timer overflow
;    adiw r24,0x01   ; inc counter
    add r4,r8
    rol r12;
    add r5,r9
    rol r12;
    add r6,r10
    rol r12;
    add r7,r11
    rol r12;
    out 0x18,r12
    dec r13
    breq bla2
    reti
bla2:
    add r8,r16
    add r9,r17
    add r10,r18
    add r11,r19
    dec r20
    breq bla3
    reti
bla3:
    lpm r20,z+
    lpm r16,z+
    lpm r17,z+
    lpm r18,z+
    lpm r19,z+
    cpi r16,0x88; end?
    breq bla4
    reti
bla4:
    ldi r22,0xf; all on
    out 0x18,r22
    cli
    rjmp bla4

coldstart:
    eor r1,r1 ; put const=0 in r1
    out 0x3f,r1 ; clear flags, disable irq
    ldi r23,0x9f
    out 0x3d,r23 ; set stackptr
    ori r18,0x40
    andi r22,0x25
    andi r22,0x57
    ori r23,0x54
    ori r23,0x57
    ori r22,0x1b
    and r2,r0
    ldi r22,0x02;
    mov r2,r22   ; put const values in r2,r3
    ldi r22,0xcb
    mov r3,r22
    ldi r22,0x80
    out 0x26,r22
    out 0x26,r1 ; switch to 9.6MHz clk
    ldi r22,0x40
    out 0x35,r22 ; MCUCR = 0x40 ; disable pull ups
    out 0x2f,r1  ; TCCR0A = 0
    ldi r22,0x01
    out 0x33,r22 ; TCCR0B = (1<<CS00)
    out 0x39,r1  ; TIMSK = 0;
    ldi r22,0x04
    out 0x03,r22 ; ADCSRB = (1<<ADTS2)
    ldi r22,0x62
    out 0x07,r22 ; ADMUX
    ldi r22,0xec
    out 0x06,r22 ; ADCSRA
    ldi r22,0x10
    out 0x14,r22 ; DIDR0 = (1<<ADC2D)
    ldi r22,0x0f
    out 0x17,r22
    out 0x18,r1; all off
    mov r8,r1
    mov r9,r1
    mov r10,r1
    mov r11,r1
    ldi r30, lo8(table)
    ldi r31, hi8(table)
    lpm r20,z+
    lpm r16,z+
    lpm r17,z+
    lpm r18,z+
    lpm r19,z+
    mov r13,r1
    sei

endless_loop: ; main loop; dont alter flags here
    rjmp endless_loop

crap_int: ; we should never get here, but if make sure nothing happens.
    cli
    rjmp crap_int

;.org 0x1c0
table:
.byte 0x0f,0x00,0x00,0x00,0x01
.byte 0x10,0x00,0x00,0x00,0x00
.byte 0x0f,0x00,0x00,0x01,0x00
.byte 0x10,0x00,0x00,0x00,0x00
.byte 0x0f,0x00,0x01,0x00,0x00
.byte 0x10,0x00,0x00,0x00,0x00
.byte 0x0f,0x01,0x00,0x00,0x00
.byte 0x10,0x00,0x00,0x00,0x00

.byte 0x20,0x00,0x00,0x00,0x04
.byte 0x20,0x00,0x00,0x04,0x00
.byte 0x20,0x00,0x04,0x00,0xfc
.byte 0x20,0x04,0x00,0xfc,0x00
.byte 0x20,0x00,0xfc,0x00,0x00

.byte 0x10,0x07,0x00,0x00,0x00
.byte 0x10,0x00,0x0f,0x00,0x00
.byte 0x10,0x00,0x00,0x0f,0x00
.byte 0x10,0x00,0x00,0x00,0x0f


.byte 0x88,0x88,0x88,0x88,0x88; end marker
